#!/usr/bin/perl -w

######################################
# Soldat Server Statistics Generator #
# Version 0.07                       #
# (c) 2003 CREEQ                     #
######################################

use File::Copy;

### CONFIG ################################################################################################################

$configfile = 'sssg.conf';
$version = "0.07";

### FUNCTIONS #############################################################################################################

sub loadconfig {
  %config = ();
  open(CONFIG, $configfile) or die('ERROR: Cannot open config file.');
  @file = <CONFIG>;
  close(CONFIG);
  foreach $line (@file) {
    chomp($line);
    if ((length($line) != 0) && (substr($line, 0, 1) ne "#")) {
      ($a, $b) = split(/ = /, $line);
      $config{$a} = $b;
    }
  }
}

sub loadlanguage {
  @lang = ();
  open(LANGUAGE, "language/$config{Language}") or die('ERROR: Cannot open language file.');
  @file = <LANGUAGE>;
  close(LANGUAGE);
  foreach $line (@file) {
    chomp($line);
    if ((length($line) != 0) && (substr($line, 0, 1) ne "#")) {
      if (index($line, ':') != -1) {
        $a = substr($line, 0, index($line, ':'));
        $b = substr($line, index($line, ':')+1, length($line)-index($line, ':')-1);
        $lang[$a] = $b;
      }
    }
  }
  @months = split(',', $lang[11]);
}

sub loadstyle {
  %lang = ();
  open(STYLE, "style/$config{Style}/style.conf") or die('ERROR: Cannot open stlye.');
  @file = <STYLE>;
  close(STYLE);
  foreach $line (@file) {
    chomp($line);
    if ((length($line) != 0) && (substr($line, 0, 1) ne "#")) {
      ($a, $b) = split(/ = /, $line);
      $style{$a} = $b;
    }
  }
}

sub cmpdate {
  # 0 -> date1 is erlier than date2
  # 1 -> date1 is equal as date2
  # 2 -> date1 is later than date2
  ($d1, $m1, $y1) = split(/\./, $_[0]);
  ($d2, $m2, $y2) = split(/\./, $_[1]);
  if ($y1 < $y2) { return(0); } else { if ($y1 > $y2) { return(2); } else {
    if ($m1 < $m2) { return(0); } else { if ($m1 > $m2) { return(2); } else {
      if ($d1 < $d2) { return(0); } else { if ($d1 > $d2) { return(2); } else { return(1); } } } }
    }
  }
}

sub generatestat {
  @killlog = `cat $config{LogDir}kills/*.txt`;
  $TotalSelfKills = 0;
  $TotalKills = 0;
  if (defined $config{IgnoreUsers}) { @ignores = (split(/;/, $config{IgnoreUsers}), ''); }
  foreach $line (@killlog) {
    chomp($line);
    if (substr($line, 0, 1) ne " ") {
      $date = substr($line, 0, index($line, ' '));
      $time = substr($line, length($date)+1, index($line, ' ', length($date)+1)-length($date)-1);
      $killer = substr($line, length($date.$time)+2, index($line, '/')-length($date.$time)-3);
      $weapon = substr($line, rindex($line, '/')+2, length($line)-rindex($line, '/')-1);
      if ($weapon ne 'himself') { $victim = substr($line, index($line, '/')+2, rindex($line, '/')-index($line, '/')-3); }
      foreach (@ignores) {
        if ((lc $killer eq lc $_) || (lc $victim eq lc $_)) { $line = ''; last; }
      }
      if ($line eq '') { next; }

      if (defined $begindate) { if (&cmpdate($begindate, $date) == 2) { $begindate = $date; } } else { $begindate = $date; }
      if (defined $enddate) { if (&cmpdate($enddate, $date) == 0) { $enddate = $date; } } else { $enddate = $date; }
      $hour = substr($time, 0, 2);
      $month = substr($date, 3, 2);
      if (defined $playhours[$hour]) { $playhours[$hour] += 1; } else { $playhours[$hour] = 1; }
      if (defined $playmonths[$month]) { $playmonths[$month] += 1; } else { $playmonths[$month] = 1; }
      if ($weapon eq 'himself') { $TotalSelfKills += 1; }
      $TotalKills += 1;
      if ($weapon ne 'himself') {
        if (defined $players->{$killer}) {
          $players->{$killer}->{kills} += 1;
          if (defined $players->{$killer}->{weapons}->{$weapon}) { $players->{$killer}->{weapons}->{$weapon} += 1; } else { $players->{$killer}->{weapons}->{$weapon} = 1; }
        } else {
          $players->{$killer}->{kills} = 1;
          $players->{$killer}->{weapons}->{$weapon} = 1;
        }
        if (defined $players->{$victim}) {
          $players->{$victim}->{deaths} += 1;
        } else {
          $players->{$victim}->{deaths} = 1;
        }
      } else {
        if (defined $players->{$killer}) {
          $players->{$killer}->{deaths} += 1;
        } else {
          $players->{$killer}->{deaths} = 1;
        }
      }
      if ($weapon ne 'himself') { if (defined $weapons{$weapon}) { $weapons{$weapon} += 1; } else { $weapons{$weapon} = 1; } }
    }
  }
  $TotalPlayers = keys %{$players};  
}

sub sorthash {
  %original = @_;
  $max = 0;
  @order = ();
  foreach (keys %original) {
    if ($original{$_} > $max) { $max = $original{$_}; }
  }
  for ($i=$max;$i>=0;$i--) {
    foreach (keys %original) {
      if ($original{$_} == $i) { push @order, $_; }
    }
  }
  return(@order);
}

### MAIN ##################################################################################################################

$begin = time;
&loadconfig;
&loadlanguage;
&loadstyle;
&generatestat;
mkdir $config{StatDir}, 0755;
unlink "$config{StatDir}*";
copy('gfx/stat.jpg', $config{StatDir});
open(INDEX, ">$config{StatDir}index.html") or die("ERROR: Cannot write stat file.");

### HEAD ###
print INDEX "<html>\n";
print INDEX "<head>\n";
print INDEX "<title>$config{ServerName} - Soldat Server $lang[0]</title>\n";
print INDEX "</head>\n";
print INDEX "<body bgcolor=\"$style{BGColor}\" text=\"$style{TextColor}\" link=\"$style{LinkColor}\">\n";
print INDEX "<center>\n";
print INDEX "<font face=\"$style{FontFace}\" size=\"5\"><b><u>$config{ServerName}</u></b></font><br>\n";
print INDEX "<font face=\"$style{FontFace}\" size=\"2\"><b>$lang[1] <a href=\"mailto:$config{YourMail}\">$config{YourName}</a></b></font><br><br>\n";
print INDEX "<font face=\"$style{FontFace}\" size=\"2\">$lang[2] " . localtime($begin) . ".</font><br><br>\n";

## GENERAL INFO ###
if ($config{ShowGeneralInfo} == 1) {
  print INDEX "<table width=\"70%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[3]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\60%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"200\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[4]</b></font></td>\n";
  print INDEX "<td width=\"400\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$config{ServerName}</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"200\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[5]</b></font></td>\n";
  print INDEX "<td width=\"400\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$config{ServerIP} @ $config{ServerPort}</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"200\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[6]</b></font></td>\n";
  print INDEX "<td width=\"400\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$begindate - $enddate</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"200\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[7]</b></font></td>\n";
  print INDEX "<td width=\"400\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$TotalPlayers</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"200\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[8]</b></font></td>\n";
  print INDEX "<td width=\"400\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$TotalKills</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"200\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[9]</b></font></td>\n";
  print INDEX "<td width=\"400\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$TotalSelfKills</b></font></td>\n";
  print INDEX "</tr>\n";
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### KILLS BY MONTH ###
if ($config{ShowKillsByMonth} == 1) {
  print INDEX "<table width=\"70%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[10]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\60%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr>\n";
  $maxmonth = 0;
  for ($month=1;$month<=12;$month++) {
    if (!defined $playmonths[$month]) { $playmonths[$month] = 0; }
    if ($playmonths[$month] > $maxmonth) { $maxmonth = $playmonths[$month]; }
  }
  for ($month=1;$month<=12;$month++) {
    print INDEX "<td width=\"40\" bgcolor=\"$style{TableColor2}\" align=\"center\" valign=\"bottom\"><font color=\"$style{TableTopicTextColor}\" size=\"1\"><br>" . sprintf("%0.0f", $playmonths[$month]/$TotalKills*100) . "%<br><img src=\"stat.jpg\" width=\"15\" height=\"" . ($playmonths[$month]/$maxmonth*100)  . "\"></b></font></td>\n";
  }
  print INDEX "</tr><tr>\n";
  for ($month=1;$month<=12;$month++) {
    print INDEX "<td width=\"40\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"2\"><b>$months[$month-1]</b></font></td>\n";
  }
  print INDEX "</tr>\n";
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### KILLS BY HOUR ###
if ($config{ShowKillsByHour} == 1) {
  print INDEX "<table width=\"70%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[12]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\60%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr>\n";
  $maxhour = 0;
  for ($hour=0;$hour<24;$hour++) {
    if (!defined $playhours[$hour]) { $playhours[$hour] = 0; }
    if ($playhours[$hour] > $maxhour) { $maxhour = $playhours[$hour]; }
  }
  for ($hour=0;$hour<24;$hour++) {
    print INDEX "<td width=\"20\" bgcolor=\"$style{TableColor2}\" align=\"center\" valign=\"bottom\"><font color=\"$style{TableTopicTextColor}\" size=\"1\"><br>" . sprintf("%0.0f", $playhours[$hour]/$TotalKills*100) . "%<br><img src=\"stat.jpg\" width=\"15\" height=\"" . ($playhours[$hour]/$maxhour*100)  . "\"></b></font></td>\n";
  }
  print INDEX "</tr><tr>\n";
  for ($hour=0;$hour<24;$hour++) {
    print INDEX "<td width=\"20\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"2\"><b>$hour</b></font></td>\n";
  }
  print INDEX "</tr>\n";
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### TOP 10 KILLERS ###
if ($config{ShowTopKillers} == 1) {
  print INDEX "<table width=\"70%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[13]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\60%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"250\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[14]</b></font></td>\n";
  print INDEX "<td width=\"80\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[15]</b></font></td>\n";
  print INDEX "<td width=\"80\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[16]</b></font></td>\n";
  print INDEX "<td width=\"250\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[17]</b></font></td>\n";
  print INDEX "</tr>\n";
  $max = 0;
  @order = ();
  foreach (keys %{$players}) {
    if (defined $players->{$_}->{kills}) {
      if ($players->{$_}->{kills} > $max) { $max = $players->{$_}->{kills}; }
    }
  }
  for ($i=$max;$i>=0;$i--) {
    foreach (keys %{$players}) {
      if (defined $players->{$_}->{kills}) {
        if ($players->{$_}->{kills} == $i) { push @order, $_; }
      }
    }
  }
  $count = 0;
  foreach $player (@order) {
    $max = 0;
    foreach (keys %{$players->{$player}->{weapons}}) {
      if ($players->{$player}->{weapons}->{$_} > $max) { $max = $players->{$player}->{weapons}->{$_}; $favweapon = $_; }
    }
    $killsperdeath = sprintf("%0.2f", ($players->{$player}->{kills}/$players->{$player}->{deaths}));
    print INDEX "<tr>\n";
    print INDEX "<td width=\"250\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$player</b></font></td>\n";
    print INDEX "<td width=\"80\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$players->{$player}->{kills}</b></font></td>\n";
    print INDEX "<td width=\"80\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$killsperdeath</b></font></td>\n";
    print INDEX "<td width=\"250\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$favweapon</b></font></td>\n";
    print INDEX "</tr>\n";
    if (++$count == 10) { last; }
  }
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### TOP 10 VICTIMS ###
if ($config{ShowTopVictims} == 1) {
  print INDEX "<table width=\"70%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[18]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\60%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"250\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[14]</b></font></td>\n";
  print INDEX "<td width=\"80\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[19]</b></font></td>\n";
  print INDEX "</tr>\n";
  $max = 0;
  @order = ();
  foreach (keys %{$players}) {
    if (defined $players->{$_}->{deaths}) {
      if ($players->{$_}->{deaths} > $max) { $max = $players->{$_}->{deaths}; }
    }
  }
  for ($i=$max;$i>=0;$i--) {
    foreach (keys %{$players}) {
      if (defined $players->{$_}->{deaths}) {
        if ($players->{$_}->{deaths} == $i) { push @order, $_; }
      }
    }
  }
  $count = 0;
  foreach $player (@order) {
    print INDEX "<tr>\n";
    print INDEX "<td width=\"250\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$player</b></font></td>\n";
    print INDEX "<td width=\"80\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$players->{$player}->{deaths}</b></font></td>\n";
    print INDEX "</tr>\n";
    if (++$count == 10) { last; }
  }
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### USED WEAPONS ###
if ($config{ShowUsedWeapons} == 1) {
  print INDEX "<table width=\"70%\" border=\"$style{TableBorder}\" cellspacing=\"0\">\n";
  print INDEX "<tr><td bgcolor=\"$style{TableTopicColor}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[20]</b></font></td></tr>\n";
  print INDEX "</table>\n";
  print INDEX "<table width=\60%\" border=\"$style{TableBorder}\" cellspacing=\"1\">\n";
  print INDEX "<tr>\n";
  print INDEX "<td width=\"250\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[21]</b></font></td>\n";
  print INDEX "<td width=\"80\" bgcolor=\"$style{TableColor1}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$lang[22]</b></font></td>\n";
  print INDEX "</tr>\n";
  foreach $weapon (&sorthash(%weapons)) {
    print INDEX "<tr>\n";
    print INDEX "<td width=\"250\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$weapon</b></font></td>\n";
    print INDEX "<td width=\"80\" bgcolor=\"$style{TableColor2}\" align=\"center\"><font color=\"$style{TableTopicTextColor}\" size=\"3\"><b>$weapons{$weapon}</b></font></td>\n";
    print INDEX "</tr>\n";
  }
  print INDEX "</table>\n";
  print INDEX "<br><br>\n";
}

### FOOT ###
$gentime = time-$begin;
$hours = int ($gentime / 3600);
$gentime -= $hours * 3600;
$minutes = int ($gentime / 60);
$gentime -= $minutes * 60;
$seconds = $gentime;
$gentime = '';
if ($hours > 0) { $gentime = "$hours $lang[24] "; }
if ($minutes > 0) { $gentime = $gentime . "$minutes $lang[25] "; }
$gentime = $gentime . "$seconds $lang[26]";
print INDEX "<font face=\"$style{FontFace}\" size=\"1\"><b>\n";
print INDEX "<a href=\"http://fool.homelinux.org/sssg/\" target=\"_blank\">Soldat Server Statistics Generator</a> - Version $version - &copy 2003 <a href=\"mailto:creeq\@web.de?subject=solstat\">CREEQ</a><br>\n";
print INDEX "$lang[23]: $gentime\n";
print INDEX "</font>\n";
print INDEX "</center>\n";
print INDEX "</body>\n";
print INDEX "</html>\n";

close(INDEX);
